<?php
  /**************************************************
  Coppermine Plugin - Facebook Authentication
  *************************************************
  Copyright (c) 2010 Marek Paterczyk
  *************************************************
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License version 3
  as published by the Free Software Foundation.
  ***************************************************/
  if (!defined('IN_COPPERMINE'))
      die('Not in Coppermine...');

  require_once('include/init.inc.php');

  $thisplugin->add_action('page_start', 'facebookauth_register_js');
  $thisplugin->add_action('plugin_install', 'facebookauth_install');

  function facebookauth_register_js()
  {
      global $JS, $CONFIG;

      require_once($CONFIG['plugin_facebookauth_firephp_path'] . 'FirePHP.class.php');
      $fp = FirePHP::getInstance(true);
      $fp->setEnabled($CONFIG['plugin_facebookauth_debug']);

      $fp->trace("Adding javascript");
      $fbUsers = array();
      if ($CONFIG['plugin_facebookauth_show_names'] > 0) {
          $sql = "SELECT user_name, name FROM {$CONFIG['TABLE_USERS']} INNER JOIN {$CONFIG['TABLE_PREFIX']}plugin_facebookauth_users fb_users ON {$CONFIG['TABLE_USERS']}.user_id = fb_users.cpg_user_id";
          $fp->info($sql);
          $result = cpg_db_query($sql);
          while ($row = mysql_fetch_array($result)) {
              $user_name = $row['user_name'];
              $name      = $row['name'];
              if ($CONFIG['plugin_facebookauth_show_names'] == 1) {
                  // show only first name
                  $name = substr($name, 0, strpos($name, ' '));
              }
              $fp->trace("fbUsers[$user_name]=$name");
              $fbUsers[$user_name] = $name;
          }
          mysql_free_result($result);
          set_js_var('fbUsers', $fbUsers);
      }

      set_js_var('plugin_facebookauth_show_login', $CONFIG['plugin_facebookauth_show_login']);

      //$JS['includes'][0] = 'http://connect.facebook.net/en_US/all.js';
      $JS['includes'][] = 'plugins/facebookauth/facebook.js';
  }

  function facebookauth_install()
  {
      global $CONFIG;
      cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (name, value) VALUES ('plugin_facebookauth_application_id', '')");
      cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (name, value) VALUES ('plugin_facebookauth_application_secret', '')");
      cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (name, value) VALUES ('plugin_facebookauth_debug', '0')");
      cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (name, value) VALUES ('plugin_facebookauth_show_login', '1')");
      cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (name, value) VALUES ('plugin_facebookauth_show_names', '1')");
      cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (name, value) VALUES ('plugin_facebookauth_firephp_path', '../FirePHPCore/')");
      cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (name, value) VALUES ('plugin_facebookauth_newuser_notify', '1')");
      cpg_db_query("INSERT IGNORE INTO {$CONFIG['TABLE_CONFIG']} (name, value) VALUES ('plugin_facebookauth_newuser_allow', '1')");

      $create_user_table_sql = "CREATE TABLE IF NOT EXISTS `{$CONFIG['TABLE_PREFIX']}plugin_facebookauth_users` (" . "`cpg_user_id` int(11) NOT NULL," . "`name` varchar(255) COLLATE utf8_bin NOT NULL," . "PRIMARY KEY (`cpg_user_id`)" . ") ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_bin;";
      cpg_db_query($create_user_table_sql);

      return true;
  }
?>
